h=gcf;   % current figure handle
handles=guidata(h); 
% info pre handles: www.mathworks.com/matlabcentral/answers/153052-how-to-understand-gui-handles

global lw   % linewidth - hrubka ciary
lw=2;

%% nacitanie parametrov
c1=str2double(get(handles.edit1,'String'));
c2=str2double(get(handles.edit2,'String'));
m1=str2double(get(handles.edit3,'String'));
m2=str2double(get(handles.edit4,'String'));
m3=str2double(get(handles.edit5,'String'));
%F=str2double(get(handles.edit6,'String'));
b1=str2double(get(handles.edit7,'String'));
b2=str2double(get(handles.edit8,'String'));
b3=str2double(get(handles.edit9,'String'));
b4=str2double(get(handles.edit10,'String'));
wmin=str2double(get(handles.edit14,'String'));
wmax=str2double(get(handles.edit15,'String'));
Tstop=str2double(get(handles.edit16,'String'));

%% vypocet prenosov
if get(handles.radiobutton1,'Value')==1 % pre X1(s)/F(s) zobraz vysledky (grafy, poly, TF)
   num=[b1*m3, b1*(b3+b4), b1*c2];
   den=[m1*m2*m3, (b1*m1*m3+b1*m2*m3+b2*m1*m3+b3*m1*m2+b4*m1*m2+b4*m1*m3+b4*m2*m3), (b4^2*m1+b4^2*m2+b4^2*m3+b1*b3*m1+b1*b2*m3+b1*b3*m2+b1*b4*m1+b2*b3*m1+b1*b4*m2+b2*b4*m1+2*b1*b4*m3+b3*b4*m1+b2*b4*m3+b3*b4*m2+c2*m1*m2+c1*m2*m3+c2*m1*m3), (2*b1*b4^2+b2*b4^2+b3*b4^2+b4^3+b1*b2*b3+b1*b2*b4+2*b1*b3*b4+b2*b3*b4+b1*c2*m1+b1*c1*m3+b1*c2*m2+b2*c2*m1+b1*c2*m3+b2*c1*m3+b3*c1*m2+b3*c2*m1+b4*c1*m2+2*b4*c2*m1+b4*c1*m3+b4*c2*m2+b4*c2*m3), (b4^2*c1+2*b4^2*c2+b1*b2*c2+b1*b3*c1+b1*b3*c2+b1*b4*c1+b2*b3*c1+3*b1*b4*c2+b2*b4*c1+b2*b4*c2+b3*b4*c1+b3*b4*c2+c1*c2*m2+c1*c2*m3), b1*c1*c2+b2*c1*c2+b3*c1*c2+2*b4*c1*c2 ];
   % nahlad schemy (zobrazi x1 cervenym)
   axes(handles.axes5)
   imshow('obr1.bmp')               % zobrazi čb obrazok obr1.bmp na danom handles
   
   set(handles.text33,'String',''); % vymaze citatel TF
   set(handles.text34,'String',''); % vymaze menovatel TF
   
   % zapis koeficientov citatela a menovatela aktualnej TF
   set( handles.text36, 'String', [num2str(num(1)),'s^2 + ',num2str(num(2)),'s + ',num2str(num(3))]);
   set( handles.text37, 'String',[num2str(den(1)),'s^5 + ',num2str(den(2)),'s^4 + ',num2str(den(3)),'s^3 + ',num2str(den(4)),'s^2 + ',num2str(den(5)),'s + ',num2str(den(6))]);
    
elseif get(handles.radiobutton2,'Value')==1 % pre X2(s)/F(s) zobraz vysledky (grafy, poly, TF)
   num=[(m1*m3), (b1*m3+b3*m1+b4*m1+b4*m3), (b1*b3+b1*b4+b3*b4+c2*m1+c1*m3+b4^2), (b1*c2+b3*c1+b4*c1+b4*c2), (c1*c2)];
   den=[(m1*m2*m3), (b1*m1*m3+b1*m2*m3+b2*m1*m3+b3*m1*m2+b4*m1*m2+b4*m1*m3+b4*m2*m3), (b4^2*m1+b4^2*m2+b4^2*m3+b1*b3*m1+b1*b2*m3+b1*b3*m2+b1*b4*m1+b2*b3*m1+b1*b4*m2+b2*b4*m1+2*b1*b4*m3+b3*b4*m1+b2*b4*m3+b3*b4*m2+c2*m1*m2+c1*m2*m3+c2*m1*m3), (2*b1*b4^2+b2*b4^2+b3*b4^2+b4^3+b1*b2*b3+b1*b2*b4+2*b1*b3*b4+b2*b3*b4+b1*c2*m1+b1*c1*m3+b1*c2*m2+b2*c2*m1+b1*c2*m3+b2*c1*m3+b3*c1*m2+b3*c2*m1+b4*c1*m2+2*b4*c2*m1+b4*c1*m3+b4*c2*m2+b4*c2*m3), (b4^2*c1+2*b4^2*c2+b1*b2*c2+b1*b3*c1+b1*b3*c2+b1*b4*c1+b2*b3*c1+3*b1*b4*c2+b2*b4*c1+b2*b4*c2+b3*b4*c1+b3*b4*c2+c1*c2*m2+c1*c2*m3), b1*c1*c2+b2*c1*c2+b3*c1*c2+2*b4*c1*c2];
   % nahlad schemy (zobrazi x2 cervenym)
   axes(handles.axes5)
   imshow('obr2.bmp')
   
   set(handles.text33,'Enable','on');
   set(handles.text34,'Enable','on');
    
   zeros=roots(num);
   n3=round(zeros(3)*100)/100; n3=num2str(n3); n3=sprintf('z3 = %s',n3);
   set( handles.text33, 'String', n3 );
   n4=round(zeros(4)*100)/100; n4=num2str(n4); n4=sprintf('z4 = %s',n4);
   set( handles.text34, 'String', n4 );
   
   %zobrazenie prenosovej funkcie na obrazovke GUI
   set( handles.text36, 'String', [num2str(num(1)),'s^4 + ',num2str(num(2)),'s^3 + ',num2str(num(3)),'s^2 + ',num2str(num(4)),'s+ ',num2str(num(5))]);
   set( handles.text37, 'String', [num2str(den(1)),'s^5 + ',num2str(den(2)),'s^4 + ',num2str(den(3)),'s^3 + ',num2str(den(4)),'s^2 + ',num2str(den(5)),'s + ',num2str(den(6))]);

elseif get(handles.radiobutton3,'Value')==1 % pre X3(s)/F(s) zobraz vysledky (grafy, poly, TF)
   num=[(c2*m1), (b1*c2+b4*c2), (c1*c2)];
   den=[(m1*m2*m3), (b1*m1*m3+b1*m2*m3+b2*m1*m3+b3*m1*m2+b4*m1*m2+b4*m1*m3+b4*m2*m3), (b4^2*m1+b4^2*m2+b4^2*m3+b1*b3*m1+b1*b2*m3+b1*b3*m2+b1*b4*m1+b2*b3*m1+b1*b4*m2+b2*b4*m1+2*b1*b4*m3+b3*b4*m1+b2*b4*m3+b3*b4*m2+c2*m1*m2+c1*m2*m3+c2*m1*m3), (2*b1*b4^2+b2*b4^2+b3*b4^2+b4^3+b1*b2*b3+b1*b2*b4+2*b1*b3*b4+b2*b3*b4+b1*c2*m1+b1*c1*m3+b1*c2*m2+b2*c2*m1+b1*c2*m3+b2*c1*m3+b3*c1*m2+b3*c2*m1+b4*c1*m2+2*b4*c2*m1+b4*c1*m3+b4*c2*m2+b4*c2*m3), (b4^2*c1+2*b4^2*c2+b1*b2*c2+b1*b3*c1+b1*b3*c2+b1*b4*c1+b2*b3*c1+3*b1*b4*c2+b2*b4*c1+b2*b4*c2+b3*b4*c1+b3*b4*c2+c1*c2*m2+c1*c2*m3), (b1*c1*c2+b2*c1*c2+b3*c1*c2+2*b4*c1*c2)];
   % nahlad schemy (zobrazi x3 cervenym)
   axes(handles.axes5)
   imshow('obr3.bmp')
    
   set(handles.text33,'String','');
   set(handles.text34,'String','');
    
   %zobrazenie prenosovej funkcie    
   set( handles.text36, 'String', [num2str(num(1)),'s^2 + ',num2str(num(2)),'s + ',num2str(num(3))]);
   set( handles.text37, 'String',[num2str(den(1)),'s^5 + ',num2str(den(2)),'s^4 + ',num2str(den(3)),'s^3 + ',num2str(den(4)),'s^2 + ',num2str(den(5)),'s + ',num2str(den(6))]);
end

%vypocet korenov menovatela (polov)
poles=roots(den);

%priradenie vypocitanych polov (a ich zaokruhlenie)
p1=round(poles(1)*100)/100; p1=num2str(p1); p1=sprintf('s1 = %s',p1);
p2=round(poles(2)*100)/100; p2=num2str(p2); p2=sprintf('s2 = %s',p2);
p3=round(poles(3)*100)/100; p3=num2str(p3); p3=sprintf('s3 = %s',p3);
p4=round(poles(4)*100)/100; p4=num2str(p4); p4=sprintf('s4 = %s',p4);
p5=round(poles(5)*100)/100; p5=num2str(p5); p5=sprintf('s5 = %s',p5);

% zobrazenie vypocitanych polov
set( handles.text24, 'String', p1 );
set( handles.text25, 'String', p2 );
set( handles.text26, 'String', p3 );
set( handles.text27, 'String', p4 );
set( handles.text28, 'String', p5 );
 
% vypocet korenov citatela (nul)
zeros=roots(num);
%zobrazenie vypocitanych nul
n1=round(zeros(1)*100)/100; n1=num2str(n1); n1=sprintf('z1 = %s',n1); set( handles.text31, 'String', n1 );
n2=round(zeros(2)*100)/100; n2=num2str(n2); n2=sprintf('z2 = %s',n2); set( handles.text32, 'String', n2 );

%% vykreslenie grafov 
axes(handles.axes1) % nastavenie oblasti, kde sa bude kreslit
step(num,den,Tstop); grid on; title('Step Response','Fontsize',12);
set(findall(gcf,'type','line'),'linewidth',lw);

axes(handles.axes2)
bode(num,den,{wmin wmax}), grid on, title('Bode Diagram','Fontsize',12);
set(findall(gcf,'type','line'),'linewidth',lw);

% zobrazenie nyquist 
axes(handles.axes3), nyquist(num,den), grid on, title('Nyquist Diagram','Fontsize',12);
set(findall(gcf,'type','line'),'linewidth',lw);

% zobrazenie pzmap 
axes(handles.axes4), pzmap(num,den), title('Pole-Zero Map','Fontsize',12);
set(findall(gcf,'type','line'),'linewidth',lw);